// --- [ dcf_bits.c ] ----------------------------------------------------------
//       30.11.09
//     schreibt und liest die DCF_Bits in einem Array von 8 Byte (= 64 Bits)
//
// ----------------------------------------------------------------------------

#include <avr/io.h>
#include <inttypes.h>
#include <avr/pgmspace.h>
//#include <stdlib.h>
#include "global.h"
#include "rs232.h"
#include "dcf_77.h"

extern volatile uint8_t flag;
extern volatile uint8_t error;

uint8_t dcf_bits[8];			// lokale Variable fr 64 Bits
uint8_t bit_idx = 0;			// lokaler Zhler fr DCF-Bit-Nummer

// ----------------------------------------------------------------------------
// resetet alle Bits
// und (das ist wichtig !) setzt den Index auf 0 zurck
void DCF_reset_bits(void)
{
register uint8_t i = 8;		// Byte 7 .. 0 kopieren und dann lschen

do	{
	i--;
//	time[BITS][i] = dcf_bits[i];// eine Kopie der Bits anlegen in globalem Array
	dcf_bits[i] = 0;			// Inhalt lschen
	} while (i);
bit_idx = 0;					// den Index fr die nchste Minute zurcksetzen
}

// ----------------------------------------------------------------------------
// setzt den Bit-Wert von DCF_in in die nchste frei Bitposition
// incrementiert den Index bit_idx, solange dieser < 63

void DCF_save_bit(uint8_t v)
{
uint8_t i,j;

j = bit_idx / 8;			// das zustndige Byte aus dem Index ermitteln
i = bit_idx % 8;			// Bitposition
								// Index auf die folgende Position setzen
								// berlauf ber Arraygrenzen verhindern
if (bit_idx < 63) bit_idx++; else error |= (1<<ERR_BIT_CNT);

if (v) dcf_bits[j] |= (1<<i); else dcf_bits[j] &= ~(1<<i);

if (bit_idx == 59) flag |= (1<<DCF_RX_58);

}

// ----------------------------------------------------------------------------
// holt in einem Array von 8 Byte das Bit x (0..63)
uint8_t DCF_get_bit(uint8_t bit)
{
uint8_t i, j, r;

j = bit / 8;			// das zustndige Byte aus dem Index ermitteln
i = bit % 8;			// Bitposition

r = (dcf_bits[j] & (1<<i));
if (r) r = 1;
return(r);
}


// ----------------------------------------------------------------------------
// gibt zurck, ob alle DCF-Bits empfangen worden sind,
// d.h. der Index muss genau auf 59 stehen, dann sind alle Bits eingegangen
uint8_t DCF_bits_complete(void)
{
return(bit_idx == 59);
}


// --- [ eof ] ----------------------------------------------------------------